/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 27/06/22.
//

#ifndef FGGL_SUBSYSTEM_PROVIDER_HPP
#define FGGL_SUBSYSTEM_PROVIDER_HPP

#include "fggl/audio/audio.hpp"
#include "fggl/gui/gui.hpp"
#include "fggl/ecs3/types.hpp"
#include "fggl/input/input.hpp"

namespace fggl::subsystem {

	class ServiceProvider {
		public:
			virtual audio::AudioService* getAudio() = 0;
			virtual gui::FontLibrary* getFontLibrary() = 0;
			virtual input::Input* getInput() = 0;
			virtual data::Storage* getStorage() = 0;
			virtual ecs3::TypeRegistry* getTypeRegistry() = 0;
	};

} // namespace fggl::subsystem

#endif //FGGL_SUBSYSTEM_PROVIDER_HPP
