/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 27/06/22.
//

#ifndef FGGL_SUBSYSTEM_TYPES_HPP
#define FGGL_SUBSYSTEM_TYPES_HPP


namespace fggl::subsystem {

	class ServiceProvider;

	class Subsystem {
			virtual ~Subsystem() = default;

			virtual void setup(ServiceProvider& provider) = 0;
			virtual void teardown(ServiceProvider& provider) = 0;
	};

} // namespace fggl::subsystem

#endif //FGGL_SUBSYSTEM_TYPES_HPP
